diff --git a/gcc/analyzer/impl-4.cc b/gcc/analyzer/impl-4.cc
index b12102c..5089c16 100644
--- a/gcc/analyzer/impl-4.cc
+++ b/gcc/analyzer/impl-4.cc
@@ -2817,282 +3549,380 @@ exploded_edge::dump_dot (graphviz_out *gv) const
   pp_printf (pp, "\"];\n");
 }
 
-
 ////////////////////////////////////////////////////////////////////////////
 
-/* exploded_graph's ctor.  */
+/* struct stats.  */
 
-exploded_graph::exploded_graph (const supergraph &sg, logger *logger,
-				const extrinsic_state &ext_state,
-				int verbosity)
-: log_user (logger), m_sg (sg), m_ext_state (ext_state),
-  m_verbosity (verbosity),
-  m_node_reuse_count (0)
+/* FIXME.  */
+
+stats::stats (int num_supernodes)
+: m_node_reuse_count (0),
+  m_path_vars_purged (0),
+  m_num_supernodes (num_supernodes)
 {
   for (int i = 0; i < NUM_POINT_KINDS; i++)
     m_num_nodes[i] = 0;
-
-  m_origin = get_or_create_node (program_point (NULL, NULL, 0, PK_ORIGIN,
-						call_string ()),
-				 program_state (ext_state));
 }
 
-/* Ensure that there is an exploded_node representing an external call to
-   FUN, adding it to the worklist if creating it.
-
-   Add an edge from the origin exploded_node to the function entrypoint
-   exploded_node.  */
+/* FIXME.  */
 
 void
-exploded_graph::add_function_entry (function *fun)
+stats::log (logger *logger) const
 {
-  program_point point = program_point::from_function_entry (m_sg, fun);
-  program_state state (m_ext_state);
-
-  add_edge (m_origin, get_or_create_node (point, state), NULL);
+  gcc_assert (logger);
+  for (int i = 0; i < NUM_POINT_KINDS; i++)
+    logger->log ("m_num_nodes[%s]: %i",
+		 point_kind_to_string (static_cast <enum point_kind> (i)),
+		 m_num_nodes[i]);
+  logger->log ("m_node_reuse_count: %i", m_node_reuse_count);
+  logger->log ("m_path_vars_purged: %i", m_path_vars_purged);
 }
 
-/* Get or create an exploded_node for (POINT, STATE).
-   If a new node is created, it is added to the worklist.  */
+/* FIXME.  */
 
-exploded_node *
-exploded_graph::get_or_create_node (const program_point &point,
-				    const program_state &state)
+void
+stats::dump (FILE *out) const
 {
-  JIT_LOG_FUNC (get_logger ());
+  for (int i = 0; i < NUM_POINT_KINDS; i++)
+    fprintf (out, "m_num_nodes[%s]: %i\n",
+	     point_kind_to_string (static_cast <enum point_kind> (i)),
+	     m_num_nodes[i]);
+  fprintf (out, "m_node_reuse_count: %i\n", m_node_reuse_count);
+  fprintf (out, "m_path_vars_purged: %i\n", m_path_vars_purged);
+
+  if (m_num_supernodes > 0)
+    fprintf (out, "PK_AFTER_SUPERNODE nodes per supernode: %.2f\n",
+	     (float)m_num_nodes[PK_AFTER_SUPERNODE] / (float)m_num_supernodes);
+}
 
-  /* Prune state to try to improve the chances of a cache hit,
-     avoiding generating redundant nodes.  */
-  program_state pruned_state = state.prune_for_point (*this, point);
+////////////////////////////////////////////////////////////////////////////
 
-  point_and_state ps (point, pruned_state);
-  if (exploded_node **slot = m_point_and_state_to_node.get (ps))
-    {
-      /* An exploded_node for PS already exists.  */
-      log ("reused EN: %i", (*slot)->m_index);
-      m_node_reuse_count++;
-      return *slot;
-    }
+/* class saved_diagnostic.  */
 
-  /* An exploded_node for PS doesn't already exist; create one.  */
-  exploded_node *node = new exploded_node (ps, m_ext_state, m_nodes.length ());
-  add_node (node);
-  m_point_and_state_to_node.put (ps, node);
-  ++m_num_nodes[node->get_point ().m_kind];
+/* FIXME.  */
 
-  if (get_logger ())
-    {
-      log ("created EN: %i", node->m_index);
-      log ("point: %s",
-	   point.to_str ().c_str ());
-      log ("pruned_state: %s",
-	   pruned_state.to_str (m_ext_state).c_str ());
-    }
+saved_diagnostic::saved_diagnostic (const state_machine &sm,
+				    const exploded_node *enode,
+				    const supernode *node, const gimple *stmt,
+				    stmt_finder *stmt_finder,
+				    tree var, state_machine::state_t state,
+				    pending_diagnostic *d)
+: m_sm (sm), m_enode (enode), m_node (node), m_stmt (stmt),
+ /* stmt_finder could be on-stack; we want our own copy that can
+    outlive that.  */
+  m_stmt_finder (stmt_finder ? stmt_finder->clone () : NULL),
+  m_var (var), m_state (state),
+  m_d (d)
+{
+}
 
-  /* Add the new node to the worlist.  */
-  m_worklist.safe_push (node);
-  return node;
+/* FIXME.  */
+
+saved_diagnostic::~saved_diagnostic ()
+{
+  delete m_stmt_finder;
+  delete m_d;
 }
 
-/* Add an exploded_edge from SRC to DEST, recording its association
-   with SEDGE (which may be NULL).  */
+////////////////////////////////////////////////////////////////////////////
 
-void
-exploded_graph::add_edge (exploded_node *src, exploded_node *dest,
-			  const superedge *sedge)
+/* class diagnostic_manager.  */
+
+/* FIXME.  */
+
+diagnostic_manager::diagnostic_manager (logger *logger, int verbosity)
+: log_user (logger), m_verbosity (verbosity)
 {
-  exploded_edge *e = new exploded_edge (src, dest, sedge);
-  digraph::add_edge (e);
-  src->m_succs.safe_push (e);
 }
 
-/* The main loop of the analysis.
-   Pop freshly-created exploded_nodes from the worklist, calling
-   process_node on them to explore the <point, state> graph.
-   Add edges to their successors, potentially creating new successors
-   (which are also added to the worklist).  */
+/* FIXME.  */
 
 void
-exploded_graph::process_worklist ()
+diagnostic_manager::add_diagnostic (const state_machine &sm,
+				    const exploded_node *enode,
+				    const supernode *node, const gimple *stmt,
+				    stmt_finder *finder,
+				    tree var, state_machine::state_t state,
+				    pending_diagnostic *d)
 {
-  while (m_worklist.length () > 0)
-    {
-      exploded_node *node = m_worklist.pop ();
-      process_node (node);
-
-      /* FIXME: make this less ad-hoc?  e.g. a param */
-      /* we use exit rather than entry since there can be multiple
-	 entry ENs, one per phi; the number of PK_AFTER_SUPERNODE ought
-	 to be equivalent to the number of supernodes multiplied by the
-	 number of states.  */
-      if (m_num_nodes[PK_AFTER_SUPERNODE]> m_sg.num_nodes () * 5)
-	{
-	  log ("bailing out; too many nodes");
-	  sorry ("analysis bailed out early");
-	  return;
-	}
-    }
+  // TODO: potentially do them directly, vs saved
+  saved_diagnostic *sd
+    = new saved_diagnostic (sm, enode, node, stmt, finder, var, state, d);
+  m_saved_diagnostics.safe_push (sd);
+  if (get_logger ())
+    log ("adding saved diagnostic %i at SN %i: %qs",
+	 m_saved_diagnostics.length () - 1,
+	 node->m_index, d->get_kind ());
 }
 
-/* The core of exploded_graph::process_worklist (the main analysis loop),
-   handling one node in the worklist.
+/* FIXME.  */
+/* we want to find the simplest dedupe_candidate amongst those that share a
+   dedupe_key.  */
 
-   Get successor <point, state> pairs for NODE, calling get_or_create on
-   them, and adding an exploded_edge to each successors.
+class dedupe_key
+{
+public:
+  dedupe_key (const saved_diagnostic &sd,
+	      const exploded_path &epath)
+  : m_sd (sd), m_stmt (sd.m_stmt)
+  {
+    /* Support deferring the choice of stmt until after an emission path has
+     been built, using an optional stmt_finder.  */
+    if (m_stmt == NULL)
+      {
+	gcc_assert (sd.m_stmt_finder);
+	m_stmt = sd.m_stmt_finder->find_stmt (epath);
+      }
+    gcc_assert (m_stmt);
+  }
 
-   Freshly-created nodes will be added to the worklist.  */
+  hashval_t hash () const
+  {
+    inchash::hash hstate;
+    hstate.add_ptr (m_stmt);
+    // TODO: m_sd
+    return hstate.end ();
+  }
+  bool operator== (const dedupe_key &other) const
+  {
+    return (m_sd == other.m_sd
+	    && m_stmt == other.m_stmt);
+  }
 
-void
-exploded_graph::process_node (exploded_node *node)
+  location_t get_location () const
+  {
+    return m_stmt->location;
+  }
+
+  /* A qsort comparator for use by dedupe_winners::emit_best
+     to sort them into location_t order.  */
+
+  static int
+  comparator (const void *p1, const void *p2)
+  {
+    const dedupe_key *pk1 = *(const dedupe_key * const *)p1;
+    const dedupe_key *pk2 = *(const dedupe_key * const *)p2;
+
+    location_t loc1 = pk1->get_location ();
+    location_t loc2 = pk2->get_location ();
+
+    return linemap_compare_locations (line_table, loc2, loc1);
+  }
+
+  // the pending_diagnostic
+  // the (stmt (non-NULL), var, state)
+  const saved_diagnostic &m_sd;
+  const gimple *m_stmt;
+};
+
+/* FIXME.  */
+class dedupe_candidate
 {
-  JIT_LOG_FUNC_1 (get_logger (), "EN: %i", node->m_index);
+public:
+  // has the exploded_path
+  dedupe_candidate  (const shortest_paths &sp,
+		     const saved_diagnostic &sd)
+  : m_epath (sp.get_shortest_path (sd.m_enode)),
+    m_num_dupes (0)
+  {
+  }
 
-  const program_point &point = node->get_point ();
-  const program_state &state = node->get_state ();
-  if (get_logger ())
-    {
-      log ("point: %s, state: %s",
-	   point.to_str ().c_str (),
-	   state.to_str (m_ext_state).c_str ());
-    }
+  unsigned length () const { return m_epath.length (); }
+  const exploded_path &get_path () const { return m_epath; }
 
-  switch (point.m_kind)
-    {
-    default:
-      gcc_unreachable ();
-    case PK_ORIGIN:
-      /* This node exists to simplify finding the shortest path
-	 to an exploded_node.  */
-      break;
+private:
+  exploded_path m_epath;
+public:
+  int m_num_dupes;
+};
 
-    case PK_BEFORE_SUPERNODE:
-      {
-	program_state next_state (state);
+/* FIXME.  */
 
-	for (gphi_iterator gpi
-	       = const_cast<supernode *>(node->get_supernode ())->start_phis ();
-	     !gsi_end_p (gpi); gsi_next (&gpi))
-	  {
-	    gphi *phi = gpi.phi ();
+class dedupe_hash_map_traits
+{
+public:
+  typedef const dedupe_key *key_type;
+  typedef dedupe_candidate *value_type;
+  typedef dedupe_candidate *compare_type;
 
-	    const cfg_superedge *last_cfg_superedge
-	      = point.m_from_edge->dyn_cast_cfg_superedge ();
-	    gcc_assert (last_cfg_superedge);
-	    // FIXME: this ought to be an as_a<>
+  static inline hashval_t hash (const key_type &v)
+  {
+    return v->hash ();
+  }
+  static inline bool equal_keys (const key_type &k1, const key_type &k2)
+  {
+    return *k1 == *k2;
+  }
+  template <typename T>
+  static inline void remove (T &)
+  {
+    // TODO
+  }
+  template <typename T>
+  static inline void mark_deleted (T &entry)
+  {
+    entry.m_key = reinterpret_cast<key_type> (1);
+  }
+  template <typename T>
+  static inline void mark_empty (T &entry)
+  {
+    entry.m_key = NULL;
+  }
+  template <typename T>
+  static inline bool is_deleted (const T &entry)
+  {
+    return entry.m_key == reinterpret_cast<key_type> (1);
+  }
+  template <typename T>
+  static inline bool is_empty (const T &entry)
+  {
+    return entry.m_key == NULL;
+  }
 
-	    tree src = last_cfg_superedge->get_phi_arg (phi);
-	    tree lhs = gimple_phi_result (phi);
+};
 
-	    /* Update next_state based on phi.  */
-	    node->on_assignment (*this,
-				 point.make_path_var (lhs),
-				 point.make_path_var (src),
-				 state,
-				 &next_state);
-	  }
+/* A map from dedupe_key to best current dedupe_candidate.  */
 
-	if (point.m_supernode->m_stmts.length () > 0)
-	  {
-	    program_point next_point
-	      = program_point::before_stmt (point.m_supernode, 0,
-					    point.m_call_string);
-	    exploded_node *next
-	      = get_or_create_node (next_point, next_state);
-	    add_edge (node, next, NULL);
-	  }
-	else
-	  {
-	    program_point next_point
-	      = program_point::after_supernode (point.m_supernode,
-						point.m_call_string);
-	    exploded_node *next = get_or_create_node (next_point, next_state);
-	    add_edge (node, next, NULL);
-	  }
-      }
-      break;
-    case PK_BEFORE_STMT:
+class dedupe_winners
+{
+public:
+  ~dedupe_winners ()
+  {
+    /* Delete all keys and candidates.  */
+    for (map_t::iterator iter = m_map.begin ();
+	 iter != m_map.end ();
+	 ++iter)
       {
-	// TODO: update state based on stmt!
-	program_point next_point
-	  = program_point::after_stmt (point.m_supernode, point.m_stmt_idx,
-				       point.m_call_string);
-	program_state next_state = node->on_stmt (*this);
-	exploded_node *next = get_or_create_node (next_point, next_state);
-	add_edge (node, next, NULL);
+	delete (*iter).first;
+	delete (*iter).second;
       }
-      break;
-    case PK_AFTER_STMT:
+  }
+
+  void add (const shortest_paths &sp,
+	    const saved_diagnostic &sd)
+  {
+    dedupe_candidate *dc = new dedupe_candidate (sp, sd);
+    dedupe_key *key = new dedupe_key (sd, dc->get_path ());
+    if (dedupe_candidate **slot = m_map.get (key))
       {
-	unsigned next_idx = point.m_stmt_idx + 1;
-	if (next_idx < point.m_supernode->m_stmts.length ())
+	(*slot)->m_num_dupes++;
+
+	if (dc->length () < (*slot)->length ())
 	  {
-	    program_point next_point
-	      = program_point::before_stmt (point.m_supernode, next_idx,
-					    point.m_call_string);
-	    exploded_node *next
-	      = get_or_create_node (next_point, state);
-	    add_edge (node, next, NULL);
+	    /* We've got a shorter path for the key; replace
+	       the current candidate.  */
+	    dc->m_num_dupes = (*slot)->m_num_dupes;
+	    delete *slot;
+	    *slot = dc;
 	  }
 	else
-	  {
-	    program_point next_point
-	      = program_point::after_supernode (point.m_supernode,
-						point.m_call_string);
-	    exploded_node *next = get_or_create_node (next_point, state);
-	    add_edge (node, next, NULL);
-	  }
+	  /* We haven't beaten the current best candidate;
+	     drop the new candidate.  */
+	  delete dc;
+	delete key;
       }
-      break;
-    case PK_AFTER_SUPERNODE:
-      {
-	/* If this is an EXIT BB, detect leaks.  */
-	if (point.m_supernode->return_p ())
-	  node->detect_leaks (*this);
+    else
+      /* This is the first candidate for this key.  */
+      m_map.put (key, dc);
+  }
 
-	/* Traverse into successors of the supernode.  */
-	int i;
-	superedge *succ;
-	FOR_EACH_VEC_ELT (point.m_supernode->m_succs, i, succ)
-	  {
-	    log ("considering SN: %i -> SN: %i",
-		 succ->m_src->m_index, succ->m_dest->m_index);
+ /* Emit the simplest diagnostic within each set.  */
 
-	    program_point next_point
-	      = program_point::before_supernode (succ->m_dest, succ,
-						 point.m_call_string);
-	    program_state next_state (state);
+  void emit_best (diagnostic_manager *dm,
+		  const exploded_graph &eg,
+		  const shortest_paths &sp)
+  {
+    JIT_LOG_SCOPE (dm->get_logger ());
 
-	    if (!node->on_edge (*this, succ, &next_point, &next_state))
-	      {
-		log ("skipping impossible edge to SN: %i",
-		     succ->m_dest->m_index);
-		continue;
-	      }
+    /* Get keys into a vec for sorting.  */
+    auto_vec<const dedupe_key *> keys;
+    for (map_t::iterator iter = m_map.begin ();
+	 iter != m_map.end ();
+	 ++iter)
+      keys.safe_push ((*iter).first);
 
-	    exploded_node *next = get_or_create_node (next_point, next_state);
-	    add_edge (node, next, succ);
-	  }
+    dm->log ("# keys after de-duplication: %i", keys.length ());
+
+    /* Sort into a good emission order.  */
+    keys.qsort (dedupe_key::comparator);
+
+    /* Emit the best candidate for each key.  */
+    int i;
+    const dedupe_key *key;
+    FOR_EACH_VEC_ELT (keys, i, key)
+      {
+	dedupe_candidate **slot = m_map.get (key);
+	gcc_assert (*slot);
+	const dedupe_candidate &dc = **slot;
+
+	dm->emit_saved_diagnostic (eg, key->m_sd,
+				   dc.get_path (), key->m_stmt,
+				   dc.m_num_dupes);
       }
-      break;
-    }
+  }
+
+private:
+
+  typedef hash_map<const dedupe_key *, dedupe_candidate *,
+		   dedupe_hash_map_traits> map_t;
+  map_t m_map;
+};
+
+/* FIXME.  */
+
+void
+diagnostic_manager::emit_saved_diagnostics (const exploded_graph &eg)
+{
+  JIT_LOG_SCOPE (get_logger ());
+  auto_client_timevar tv ("emit saved diagnostics");
+  log ("# saved diagnostics: %i", m_saved_diagnostics.length ());
+
+  if (m_saved_diagnostics.length () == 0)
+    return;
+
+  /* Compute the shortest_paths once, sharing it between all diagnostics.  */
+  shortest_paths sp (eg);
+
+  // FIXME: implement a way to disable de-duplication
+  /* FIXME: add stats on de-duplication, and a way to show the
+     number of duplicates (e.g. via an option that adds a message.
+     Add a DejaGnu test for this  */
+
+  // FIXME: this isn't true:
+  /* De-duplicate the diagnostics by generating a collection of diagnostic_set,
+     picking the diagnostic with the shortest path within each set.  */
+#if 1
+  dedupe_winners best_candidates;
+
+  int i;
+  saved_diagnostic *sd;
+  FOR_EACH_VEC_ELT (m_saved_diagnostics, i, sd)
+    best_candidates.add (sp, *sd);
+
+  best_candidates.emit_best (this, eg, sp);
+
+#else
+  // TODO: for now, just emit them all
+
+  int i;
+  saved_diagnostic *sd;
+  FOR_EACH_VEC_ELT (m_saved_diagnostics, i, sd)
+    emit_saved_diagnostic (eg, sp, *sd);
+#endif
 }
 
 /* FIXME.  */
 
 void
-exploded_graph::emit_diagnostic (const state_machine &sm,
-				 const exploded_node *enode,
-				 const supernode *node, const gimple *stmt,
-				 stmt_finder *stmt_finder,
-				 tree var, state_machine::state_t state,
-				 pending_diagnostic *d) const
-{
-  /* TODO: generate a path.  */
-  /* TODO: cache the diagnostics, and flush them all at the
-     end, with one shortest_paths instance, and so finding
-     the shortest path, rather than just the first path.  */
-  shortest_paths sp (*this);
-  exploded_path epath (sp.get_shortest_path (enode));
+diagnostic_manager::emit_saved_diagnostic (const exploded_graph &eg,
+					   const saved_diagnostic &sd,
+					   const exploded_path &epath,
+					   const gimple *stmt,
+					   int num_dupes)
+{
+  JIT_LOG_SCOPE (get_logger ());
+  log ("num dupes: %i", num_dupes);
+
   pretty_printer *pp = global_dc->printer->clone ();
 
   checker4_path emission_path;
@@ -3179,7 +4009,7 @@ exploded_graph::emit_diagnostic (const state_machine &sm,
       /* Add state change events for the states that have changed.  */
       const program_state &src_state = src_node->get_state ();
       const program_state &dst_state = dst_node->get_state ();
-      const extrinsic_state &ext_state = m_ext_state;
+      const extrinsic_state &ext_state = eg.get_ext_state ();
       gcc_assert (src_state.m_checker_states.length ()
 		  == ext_state.m_checkers.length ());
       gcc_assert (dst_state.m_checker_states.length ()
@@ -3187,9 +4017,11 @@ exploded_graph::emit_diagnostic (const state_machine &sm,
       for (unsigned i = 0; i < ext_state.m_checkers.length (); i++)
 	{
 	  const state_machine &sm = ext_state.get_sm (i);
-	  const sm_state_map &src_smap = *src_state.m_checker_states[i];
-	  const sm_state_map &dst_smap = *dst_state.m_checker_states[i];
-	  for (sm_state_map::iterator_t iter = dst_smap.begin ();
+	  const sm_state_map<path_var> &src_smap
+	    = *src_state.m_checker_states[i];
+	  const sm_state_map<path_var> &dst_smap
+	    = *dst_state.m_checker_states[i];
+	  for (sm_state_map<path_var>::iterator_t iter = dst_smap.begin ();
 	       iter != dst_smap.end ();
 	       ++iter)
 	    {
@@ -3229,34 +4061,32 @@ exploded_graph::emit_diagnostic (const state_machine &sm,
 	}
     }
 
-  /* Support deferring the choice of stmt until after an emission path has
-     been built, using an optional stmt_finder.  */
-  if (stmt == NULL)
-    {
-      gcc_assert (stmt_finder);
-      stmt = stmt_finder->find_stmt (epath);
-      gcc_assert (stmt);
-    }
-
-  prune_path (&emission_path, sm, var, state);
-  emission_path.add_final_event (sm, enode, stmt, var, state, d);
-  emission_path.prepare_for_emission (d);
+  prune_path (&emission_path, sd.m_sm, sd.m_var, sd.m_state);
+  emission_path.add_final_event (sd.m_sm, sd.m_enode, stmt,
+				 sd.m_var, sd.m_state, sd.m_d);
+  emission_path.prepare_for_emission (sd.m_d);
 
   gcc_rich_location rich_loc (stmt->location);
   rich_loc.set_path (&emission_path);
 
-  auto_cfun sentinel (node->m_fun);
-  d->emit (&rich_loc);
+  auto_diagnostic_group d;
+  auto_cfun sentinel (sd.m_node->m_fun);
+  sd.m_d->emit (&rich_loc);
+  if (num_dupes > 0)
+    inform_n (stmt->location, num_dupes,
+	      "%i duplicate", "%i duplicates",
+	      num_dupes);
   delete pp;
 }
 
 /* FIXME.  */
 
 void
-exploded_graph::prune_path (checker4_path *path,
-			    const state_machine &sm,
-			    tree var,
-			    state_machine::state_t state ATTRIBUTE_UNUSED) const
+diagnostic_manager::prune_path (checker4_path *path,
+				const state_machine &sm,
+				tree var,
+				state_machine::state_t state
+				  ATTRIBUTE_UNUSED) const
 {
   JIT_LOG_FUNC (get_logger ());
   path->maybe_log (get_logger (), "path");
@@ -3407,17 +4237,18 @@ exploded_graph::prune_path (checker4_path *path,
 
   /* Second pass to remove redundant interprocedural information.  For
      example, given:
-     - calling "f2" from "f1"
-     --- entry to "f2"
-     --- calling "f3" from "f2"
-     ----- entry to "f3"
-     --- returning to "f2" to "f3"
-     - returning to "f1" to "f2"
+     (1)- calling "f2" from "f1"
+     (2)--- entry to "f2"
+     (3)--- calling "f3" from "f2"
+     (4)----- entry to "f3"
+     (5)--- returning to "f2" to "f3"
+     (6)- returning to "f1" to "f2"
      with no other intervening events, then none of these events are
      likely to be interesting to the user.
 
      Prune [..., call, function-entry, return, ...] triples repeatedly
-     until nothing has changed.  */
+     until nothing has changed.  For the example above, this would
+     remove events (3, 4, 5), and then remove events (1, 2, 6).  */
   bool changed = false;
   do
     {
